c***** cogram.for **** version: 07 Jul 2017 ****************************
c  Evaluate a scale-dependent covariance of the gravity data and moho.
c***********************************************************************
      subroutine cogram(n0)
      implicit none
      include 'constants.inc'
c
c Arguments:
c
      integer n0
c
c Common Blocks:
c
      integer nc(nrad),nrr
      real*8 cogm(nrad),cogr(nrad),rc(nrad),wtm(nrad),wtr(nrad)
      common/COVARI/cogm,cogr,rc,wtm,wtr,nc,nrr
c
      real*8 grav(ngi,ngj),rgdy(nti,ntj)
      common/GRAVIT/grav,rgdy
c
      character*10 site(nsta)
      integer neq(nsta),nmeas
      real*8 el(nsta),cred(nsta)
      real*8 tc(nsta),tce(nsta),vv(nsta),vve(nsta),xl(nsta),yl(nsta)
      common/INDATA/site,el,cred,tc,tce,vv,vve,xl,yl,neq,nmeas
c
      real*8 dcy(nsta),dsy(nsta)
      common/STORCS/dcy,dsy
c
c Local Variables:
c
      integer i,i1,i2,j,j1,j2,n1,n2
      real*8 ccs,r,varc,varv
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      do i=1,nrad
        cogm(i)=0d0
        wtm(i)=0d0
        cogr(i)=0d0
        wtr(i)=0d0
        rc(i)=0d0
        nc(i)=0
      enddo
c
      do n1=1,nmeas
        i1=idnint(30d0*(xl(n1)/dtr+144d0))+1
        j1=idnint(30d0*(64d0-yl(n1)/dtr))+1
        if(i1.ge.1.and.i1.le.ngi.and.j1.ge.1.and.j1.le.ngj)then
          if(grav(i1,j1).ne.-9999d0)then
            do n2=n1+1,nmeas
              ccs=dcy(n2)*dcy(n1)+dsy(n2)*dsy(n1)*dcos(xl(n2)-xl(n1))
              ccs=dmax1(dmin1(ccs,1d0),-1d0)
              r=A*dacos(ccs)
              nrr=idnint(r/del)+1
              i2=idnint(30d0*(xl(n2)/dtr+144d0))+1
              j2=idnint(30d0*(64d0-yl(n2)/dtr))+1
              if(i2.ge.1.and.i2.le.ngi.and.j2.ge.1.and.j2.le.ngj)then
                if(nrr.le.nrad.and.grav(i2,j2).ne.-9999d0.and.
     &              dabs(grav(i2,j2)-grav(i1,j1)).ge.10d0)then
                  varc=1d0/(tce(n1)*tce(n1)+tce(n2)*tce(n2))
                  cogm(nrr)=cogm(nrr)+varc*(tc(n1)-tc(n2))/(grav(i1,j1)-
     &                grav(i2,j2))
                  wtm(nrr)=wtm(nrr)+varc
                  varv=1d0/(vve(n1)*vve(n1)+vve(n2)*vve(n2))
                  cogr(nrr)=cogr(nrr)+varv*(vv(n1)-vv(n2))/(grav(i1,j1)-
     &                grav(i2,j2))
                  wtr(nrr)=wtr(nrr)+varv
                  rc(nrr)=rc(nrr)+(varc+varv)*r
                  nc(nrr)=nc(nrr)+1
                endif
              endif
            enddo
          endif
        endif
      enddo
c
      i=0
      nrr=nrad
      dowhile(i.lt.nrr)
        i=i+1
        if(nc(i).lt.5000.and.i.ne.nrr)then
          cogm(i)=cogm(i)+cogm(i+1)
          wtm(i)=wtm(i)+wtm(i+1)
          cogr(i)=cogr(i)+cogr(i+1)
          wtr(i)=wtr(i)+wtr(i+1)
          rc(i)=rc(i)+rc(i+1)
          nc(i)=nc(i)+nc(i+1)
          do j=i+1,nrr-1
            cogm(j)=cogm(j+1)
            wtm(j)=wtm(j+1)
            cogr(j)=cogr(j+1)
            wtr(j)=wtr(j+1)
            rc(j)=rc(j+1)
            nc(j)=nc(j+1)
          enddo
          nrr=nrr-1
          i=i-1
        else
          rc(i)=rc(i)/(wtm(i)+wtr(i))
          cogm(i)=cogm(i)/wtm(i)
          cogr(i)=cogr(i)/wtr(i)
        endif
      enddo
c
c     open(10,file='Plots/covar.dat',status='unknown')
      open(10,file='Plots_DLS/covar.dat',status='unknown')
      rewind(10)
      do i=1,nrr
        write(10,'(f8.3,f8.4,f11.7,i8)')rc(i)/1d3,cogm(i),cogr(i),nc(i)
      enddo
      close(10)
c
      if(n0.eq.0)then
c       open(10,file='Plots/covar0.dat',status='unknown')
        open(10,file='Plots_DLS/covar0.dat',status='unknown')
        rewind(10)
        do i=1,nrr
          write(10,'(f8.3,f8.4,f11.7,i8)')rc(i)/1d3,cogm(i),cogr(i),
     &        nc(i)
        enddo
        close(10)
      endif
c
      return
      end
