c***** updstack.for ***** version: 01 May 2017 *************************
c Read in EARS HK stack info and modify it using chi-square statistics
c   derived from the optimal interpolation estimation.  Modify the 
c   weighting again using the gravity misfit function. Identify the
c   "modified" maximum stack energy and update the estimate of best
c   crustal thickness and Vp/Vs ratio.
c***********************************************************************
      subroutine updstack(vmx,nnn,n0)
      implicit none
      include 'constants.inc'
c
c Arguments:
c
      integer n0,nnn
      real*8 vmx
c
c Common Blocks:
c
      integer ncgg,ncvg
      real*8 rhgs(100),rhwg(100),rhws(100),rkgs(100),rkwg(100),rkws(100)
      real*8 maw(100),mag(100),mas(100)
      common/CVGSTT/maw,mag,mas,rhgs,rhwg,rhws,rkgs,rkwg,rkws,ncgg,ncvg
c
      integer n,nl
      real*8 tc_err,tc_exp,vv_err,vv_exp
      common/EXPECT/tc_err,tc_exp,vv_err,vv_exp,n,nl
c
      integer nhh,nkk
      real*8 gres(40,40),prb(127)
      real*8 grmn,hhmn,hhmx,hmn,kkmn,kkmx,kmn,wtn
      common/GRAVWT/gres,prb,grmn,hhmn,hhmx,hmn,kkmn,kkmx,kmn,wtn,nhh,
     &    nkk
c
      character*10 site(nsta)
      integer neq(nsta),nmeas
      real*8 el(nsta),cred(nsta)
      real*8 tc(nsta),tce(nsta),vv(nsta),vve(nsta),xl(nsta),yl(nsta)
      common/INDATA/site,el,cred,tc,tce,vv,vve,xl,yl,neq,nmeas
c
      integer revised(nsta),settled(nsta)
      common/REVISD/revised,settled
c
      real*8 aradc,aradv,sillc,sillv,varc0,varv0
      common/SMVPAR/aradc,aradv,sillc,sillv,varc0,varv0
c
c Functions:
c
      real*8 fcdfi
c
c Local Variables:
c
      integer i,i0,i1,ii,il,ismx,ix,j,j0,j1,jj,jl,jx,k,l
      character sit5*5,sit4*4,sitt*10
      real*8 ff(201,241),fg(201,241),pro(201,241),stmp(201,241)
      real*8 amx(10),fmx(10),gmx(10),hmx(10),kmx(10),pmx(10),rmsm(9)
      real*8 dn,dobs,dpar,fact,fh,fk,gint,gwam,gwhh,gwkk,gwmx
      real*8 hh,hmxo,hmxu
      real*8 kk,kmxo,kmxu,pr,r1,r2,r3,r4,rk,rl
      real*8 smxo,smxu,sori,swam,swhh,swkk,swmx,tct,var,vvt
      real*8 wmn,wwam,x,y
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Initialize parameters of the old & updated maxima:
      hmxo=0d0
      kmxo=0d0
      smxo=0d0
      hmxu=0d0
      kmxu=0d0
      smxu=0d0
c Number of obs, number of parameters:
      dobs=4d0*dfloat(neq(n))                        ! 4 converted phase arrivals X # eqs
      dpar=2d0
c
c Best, 1-sigma, 2-sigma OI contours for plotting:
      if(site(n)(6:10).eq.'     ')then
        open(unit=13,file='HK_Stacks/'//site(n)(1:5)//'_sig.ll',
     &      status='unknown')
      elseif(site(n)(7:10).eq.'    ')then
        open(unit=13,file='HK_Stacks/'//site(n)(1:6)//'_sig.ll',
     &      status='unknown')
      elseif(site(n)(8:10).eq.'   ')then
        open(unit=13,file='HK_Stacks/'//site(n)(1:7)//'_sig.ll',
     &      status='unknown')
      elseif(site(n)(9:10).eq.'  ')then
        open(unit=13,file='HK_Stacks/'//site(n)(1:8)//'_sig.ll',
     &      status='unknown')
      elseif(site(n)(10:10).eq.' ')then
        open(unit=13,file='HK_Stacks/'//site(n)(1:9)//'_sig.ll',
     &      status='unknown')
      else
        open(unit=13,file='HK_Stacks/'//site(n)//'_sig.ll',
     &      status='unknown')
      endif
      rewind(13)
      write(13,'(f6.4,f6.2)')vv_exp,tc_exp+1d-1+el(n)/1d3
      write(13,'(f6.4,f6.2)')vv_exp+1d-3,tc_exp+el(n)/1d3
      write(13,'(f6.4,f6.2)')vv_exp,tc_exp-1d-1+el(n)/1d3
      write(13,'(f6.4,f6.2)')vv_exp-1d-3,tc_exp+el(n)/1d3
      write(13,'(a)')'>>'
      do i=1,100
        x=dfloat(i)*vv_err/5d1-vv_err
        y=tc_err*dsqrt(dabs(1d0-x*x/(vv_err*vv_err)))
        write(13,'(f6.4,f6.2)')vv_exp+x,tc_exp+y+el(n)/1d3
      enddo
      do i=1,100
        x=vv_err-dfloat(i)*vv_err/5d1
        y=tc_err*dsqrt(dabs(1d0-x*x/(vv_err*vv_err)))
        write(13,'(f6.4,f6.2)')vv_exp+x,tc_exp-y+el(n)/1d3
      enddo
      write(13,'(a)')'>>'
      do i=1,100
        x=dfloat(i)*2d0*vv_err/5d1-2d0*vv_err
        y=2d0*tc_err*dsqrt(dabs(1d0-x*x/(4d0*vv_err*vv_err)))
        write(13,'(f6.4,f6.2)')vv_exp+x,tc_exp+y+el(n)/1d3
      enddo
      do i=1,100
        x=2d0*vv_err-dfloat(i)*2d0*vv_err/5d1
        y=2d0*tc_err*dsqrt(dabs(1d0-x*x/(4d0*vv_err*vv_err)))
        write(13,'(f6.4,f6.2)')vv_exp+x,tc_exp-y+el(n)/1d3
      enddo
      close(13)
c
c Open temporary file for plotting the weight functions:
      open(unit=21,file='Facts.dat',status='unknown')
      rewind(21)
c
c Open the EARS HK stack-file and revised output file:
      if(site(n)(6:10).eq.'     ')then
        open(unit=11,file='HK_Stacks/'//site(n)(1:5)//'.xyz',
     &      status='old')
        open(unit=12,file='HK_Stacks/'//site(n)(1:5)//'_upd.xyz',
     &      status='unknown')
        open(unit=13,file='HK_Stacks/'//site(n)(1:5)//'_mxs.kha',
     &      status='unknown')
        open(unit=14,file='HK_Stacks/'//site(n)(1:5)//'.delt',
     &      status='unknown')
      elseif(site(n)(7:10).eq.'    ')then
        open(unit=11,file='HK_Stacks/'//site(n)(1:6)//'.xyz',
     &      status='old')
        open(unit=12,file='HK_Stacks/'//site(n)(1:6)//'_upd.xyz',
     &      status='unknown')
        open(unit=13,file='HK_Stacks/'//site(n)(1:6)//'_mxs.kha',
     &      status='unknown')
        open(unit=14,file='HK_Stacks/'//site(n)(1:6)//'.delt',
     &      status='unknown')
      elseif(site(n)(8:10).eq.'   ')then
        open(unit=11,file='HK_Stacks/'//site(n)(1:7)//'.xyz',
     &      status='old')
        open(unit=12,file='HK_Stacks/'//site(n)(1:7)//'_upd.xyz',
     &      status='unknown')
        open(unit=13,file='HK_Stacks/'//site(n)(1:7)//'_mxs.kha',
     &      status='unknown')
        open(unit=14,file='HK_Stacks/'//site(n)(1:7)//'.delt',
     &      status='unknown')
      elseif(site(n)(9:10).eq.'  ')then
        open(unit=11,file='HK_Stacks/'//site(n)(1:8)//'.xyz',
     &      status='old')
        open(unit=12,file='HK_Stacks/'//site(n)(1:8)//'_upd.xyz',
     &      status='unknown')
        open(unit=13,file='HK_Stacks/'//site(n)(1:8)//'_mxs.kha',
     &      status='unknown')
        open(unit=14,file='HK_Stacks/'//site(n)(1:8)//'.delt',
     &      status='unknown')
      elseif(site(n)(10:10).eq.' ')then
        open(unit=11,file='HK_Stacks/'//site(n)(1:9)//'.xyz',
     &      status='old')
        open(unit=12,file='HK_Stacks/'//site(n)(1:9)//'_upd.xyz',
     &      status='unknown')
        open(unit=13,file='HK_Stacks/'//site(n)(1:9)//'_mxs.kha',
     &      status='unknown')
        open(unit=14,file='HK_Stacks/'//site(n)(1:9)//'.delt',
     &      status='unknown')
      else
        open(unit=11,file='HK_Stacks/'//site(n)//'.xyz',
     &      status='old')
        open(unit=12,file='HK_Stacks/'//site(n)//'_upd.xyz',
     &      status='unknown')
        open(unit=13,file='HK_Stacks/'//site(n)//'_mxs.kha',
     &      status='unknown')
        open(unit=14,file='HK_Stacks/'//site(n)//'.delt',
     &      status='unknown')
      endif
      rewind(11)
      rewind(12)
      rewind(13)
      rewind(14)
c
c Scaling from the amplitude stack maximum likelihood:
      swmx=0d0
      if(wtn.gt.25d0)then
        gwmx=0d0
      endif
c
c Read in the stack data:
1     read(11,*,end=2)kk,hh,sori
        ii=idnint((kk-kkmn)/2.5d-3)+1
        hh=hh-el(n)/1d3
        jj=idnint((hh-hhmn)/2.5d-1)+1
c Modifier to reflect mineralogically probable K values:
        fk=1d0
        if(kk.lt.1.75d0)then
          fk=(kk-1.69d0)/6d-2
        elseif(kk.gt.1.87d0)then
          fk=(1.95d0-kk)/8d-2
        endif
        fk=dmax1(0d0,fk)
c Modifier to delimit possible thickness based on crustal refraction data:
        fh=1d0
        if(hh.gt.55d0)fh=(60d0-hh)/5d0
c       if(xl(n)/dtr.lt.-115d0.and.hh.gt.45d0)then
c         fh=(50d0-hh)/5d0
c       elseif(xl(n)/dtr.gt.-111d0.and.xl(n)/dtr.lt.-103d0.and.
c    &      -yl(n)/dtr+9d1.gt.36d0.and.hh.lt.37d0)then
c         fh=(hh-32d0)/5d0
c       endif
        fh=dmax1(0d0,fh)
c
        if(sori.gt.smxo)then
          smxo=sori
          kmxo=kk
          hmxo=hh
        endif
        var=((kk-vv_exp)/vv_err)**2+((hh-tc_exp)/tc_err)**2      ! Assume uncorrelated, normal
        pr=dexp(-var/2d0)
        ff(ii,jj)=pr
        if(ff(ii,jj).gt.swmx)then
          swmx=ff(ii,jj)
          swam=sori
          swhh=hh
          swkk=kk
        endif
        if(wtn.gt.25d0)then
          k=idint((hh-hhmn)/2.5d0)+1
          k=min0(max0(1,k),nhh)
          rk=(hh-2.5d0*dfloat(k-1)-hhmn)/2.5d0
          l=idint((kk-kkmn)/2.5d-2)+1
          l=min0(max0(1,l),nkk)
          rl=(kk-2.5d-2*dfloat(l-1)-kkmn)/2.5d-2
c Bilinear interpolation:
c         gint=(gres(k,l)+rl*(gres(k,l+1)-gres(k,l))+rk*(gres(k+1,l)-
c    &        gres(k,l))+rl*rk*(gres(k+1,l+1)+gres(k,l)-gres(k,l+1)-
c    &        gres(k+1,l)))
c Bicubic interpolation:
          call bicubic(k,l,rk,rl,gint)
          gint=dmax1(gint,grmn)
          pr=0d0
          do i=1,99
            if(gint.ge.prb(i).and.gint.lt.prb(i+1))then
              pr=(dfloat(i-1)+(gint-prb(i))/(prb(i+1)-prb(i)))/1d2
            endif
          enddo
          do i=100,108
            if(gint.ge.prb(i).and.gint.lt.prb(i+1))then
              pr=(99d0+1d-1*(dfloat(i-100)+(gint-prb(i))/(prb(i+1)-
     &            prb(i))))/1d2
            endif
          enddo
          do i=109,117
            if(gint.ge.prb(i).and.gint.lt.prb(i+1))then
              pr=(99.9d0+1d-2*(dfloat(i-109)+(gint-prb(i))/(prb(i+1)-
     &            prb(i))))/1d2
            endif
          enddo
          do i=118,126
            if(gint.ge.prb(i).and.gint.lt.prb(i+1))then
              pr=(99.99d0+1d-3*(dfloat(i-118)+(gint-prb(i))/(prb(i+1)-
     &            prb(i))))/1d2
            endif
          enddo
          if(gint.gt.prb(127))then
            pr=1d0
          endif
          pr=1d0-pr
          fg(ii,jj)=pr
          if(fg(ii,jj).gt.gwmx)then
            gwmx=fg(ii,jj)
            gwam=sori
            gwhh=hh
            gwkk=kk
          endif
          pro(ii,jj)=ff(ii,jj)*fg(ii,jj)
          write(21,*),kk,hh+el(n)/1d3,ff(ii,jj),fg(ii,jj),pro(ii,jj)
c Modify to reflect mineralogically probable K values:
          stmp(ii,jj)=sori*pro(ii,jj)*fk*fh
        else
          pro(ii,jj)=ff(ii,jj)
          write(21,*),kk,hh+el(n)/1d3,ff(ii,jj),0d0,ff(ii,jj)
c Modify to reflect mineralogically probable K values:
          stmp(ii,jj)=sori*ff(ii,jj)*fk*fh
        endif
        if(stmp(ii,jj).gt.smxu)then
          smxu=stmp(ii,jj)
          kmxu=kk
          hmxu=hh
          wwam=sori
          if(settled(n).eq.0)cred(n)=pro(ii,jj)
        endif
        write(12,'(f6.4,f6.2,f14.10)')kk,hh+el(n)/1d3,stmp(ii,jj)
      goto1
2     close(11)
      close(12)
      close(21)
c
c Find and write local maxima:
      do i=1,10
        amx=-999d0
      enddo
      ix=idnint((kkmx-kkmn)/2.5d-3)+1
      jx=idnint((hhmx-hhmn)/2.5d-1)+1
      il=idnint(dsqrt(varv0)/2.5d-3/2d0)
      jl=idnint(dsqrt(varc0)/2.5d-1/2d0)
      do jj=1,jx
        j0=max(jj-jl,1)
        j1=min(jj+jl,jx)
        do ii=1,ix
          i0=max(ii-il,1)
          i1=min(ii+il,ix)
          ismx=1
          do j=j0,j1
            do i=i0,i1
              if(stmp(i,j).gt.stmp(ii,jj))ismx=0
            enddo
          enddo
          if(ismx.eq.1.and.stmp(ii,jj).gt.amx(10))then
            if(stmp(ii,jj).gt.amx(1))then
              do i=10,2,-1
                amx(i)=amx(i-1)
                hmx(i)=hmx(i-1)
                kmx(i)=kmx(i-1)
                fmx(i)=fmx(i-1)
                gmx(i)=gmx(i-1)
                pmx(i)=pmx(i-1)
              enddo
              amx(1)=stmp(ii,jj)
              hmx(1)=hhmn+dfloat(jj-1)*2.5d-1
              kmx(1)=kkmn+dfloat(ii-1)*2.5d-3
              fmx(1)=ff(ii,jj)
              gmx(1)=fg(ii,jj)
              pmx(1)=pro(ii,jj)
            else
              do j=1,9
                if(stmp(ii,jj).lt.amx(j).and.stmp(ii,jj).ge.amx(j+1))
     &              then
                  do i=10,j+2,-1
                    amx(i)=amx(i-1)
                    hmx(i)=hmx(i-1)
                    kmx(i)=kmx(i-1)
                    fmx(i)=fmx(i-1)
                    gmx(i)=gmx(i-1)
                    pmx(i)=pmx(i-1)
                  enddo
                  amx(j+1)=stmp(ii,jj)
                  hmx(j+1)=hhmn+dfloat(jj-1)*2.5d-1
                  kmx(j+1)=kkmn+dfloat(ii-1)*2.5d-3
                  fmx(j+1)=ff(ii,jj)
                  gmx(j+1)=fg(ii,jj)
                  pmx(j+1)=pro(ii,jj)
                endif
              enddo
            endif
          endif
        enddo
      enddo
      do i=1,5
        if(amx(i).gt.0d0)then
          write(13,'(i2,f6.2,f7.4,4f6.3)')i,hmx(i)+el(n)/1d3,kmx(i),
     &        amx(i)/amx(1),pmx(i),fmx(i),gmx(i)
        endif
      enddo
      rewind(13)
c
      write(6,*)
      write(6,*)
      write(6,'(a10,i2,a9,i6)')'Iteration ',nnn,'; Update ',n0
      write(6,'(a6,a10,a24,f5.2,a6,a17,f6.2,a1)')'Site: ',site(n),
     &    '    Mean improbability: ',vmx,'-sigma',
     &    '    Credibility: ',1d2*cred(n),'%'
      write(6,'(a5,f7.2,a6,f5.2,a6,f5.2,a5,f5.2,a13,f7.4,a5,f7.4)')
     &    'Lon: ',xl(n)/dtr,' Lat: ',-yl(n)/dtr+9d1,' Tc = ',tc(n)+
     &    el(n)/1d3,' +/- ',tce(n),' km; Vp/Vs = ',vv(n),' +/- ',
     &    vve(n)
      write(6,'(a,f8.6,a,f6.4,a,f5.2,a)')'Original maximum: ',smxo,
     &    ' (Vp/Vs = ',kmxo,'; Tc = ',hmxo+el(n)/1d3,')'
      write(6,'(a17,f5.2,a5,f5.2,a9,f5.2,a5,f5.2)')'OI expected Tc: ',
     &    tc_exp+el(n)/1d3,' +/- ',tc_err,'; Vp/Vs: ',
     &    vv_exp,' +/- ',vv_err
      if(wtn.gt.25d0)then
        write(6,'(a22,f6.2,a9,f5.2,a7,f6.2,a1)')' GravMod expected Tc:',
     &      hmn+el(n)/1d3,'; Vp/Vs: ',kmn,' (Min =',grmn,')'
      endif
      write(6,'(a,f8.6,a,f6.4,a,f5.2,a)')'New maximum: ',wwam,
     &    ' (Vp/Vs = ',kmxu,'; Tc = ',hmxu+el(n)/1d3,')'
      write(6,*)
c
c     open(unit=47,file='Plots/tracks.dat',status='unknown',
      open(unit=47,file='Plots_DLS/tracks.dat',status='unknown',
     &    access='append')
      write(47,*)
      write(47,*)
      write(47,'(a10,i2,a9,i6)')'Iteration ',nnn,'; Update ',n0
      write(47,'(a6,a10,a24,f5.2,a6,a17,f6.2,a1)')'Site: ',site(n),
     &    '    Mean improbability: ',vmx,'-sigma',
     &    '    Credibility: ',1d2*cred(n),'%'
      write(47,'(a5,f7.2,a6,f5.2,a6,f5.2,a5,f5.2,a13,f7.4,a5,f7.4)')
     &    'Lon: ',xl(n)/dtr,' Lat: ',-yl(n)/dtr+9d1,' Tc = ',tc(n)+
     &    el(n)/1d3,' +/- ',tce(n),' km; Vp/Vs = ',vv(n),' +/- ',
     &    vve(n)
      write(47,'(a,f8.6,a,f6.4,a,f5.2,a)')'Original maximum: ',smxo,
     &    ' (Vp/Vs = ',kmxo,'; Tc = ',hmxo+el(n)/1d3,')'
      write(47,'(a17,f5.2,a5,f5.2,a9,f5.2,a5,f5.2)')
     &    'OI expected Tc: ',tc_exp+el(n)/1d3,' +/- ',tc_err,
     &    '; Vp/Vs: ',vv_exp,' +/- ',vv_err
      if(wtn.gt.25d0)then
        write(47,'(a22,f6.2,a9,f5.2,a7,f6.2,a1)')' GravMod expected Tc:'
     &      ,hmn+el(n)/1d3,'; Vp/Vs: ',kmn,' (Min =',grmn,')'
      endif
      write(47,'(a,f8.6,a,f6.4,a,f5.2,a)')'New maximum: ',wwam,
     &    ' (Vp/Vs = ',kmxu,'; Tc = ',hmxu+el(n)/1d3,')'
      if(settled(n).eq.0)then
        if(tc(n).ne.hmxu.or.vv(n).ne.kmxu)then
          write(14,'(a8)')'Changed:'
          write(14,'(f5.2,f7.4,a4,f6.2,f7.4)')tc(n)+el(n)/1d3,vv(n),
     &        ' -->',hmxu+el(n)/1d3,kmxu
        endif
        tc(n)=hmxu
        vv(n)=kmxu
      endif
      write(47,*)
      close(47)
      close(14)
c
c If the updated crustal thickness is within one-sigma of a tfixed value, flag:
      open(11,file='Plots_DLS/tfixed.dat',status='old')
      rewind(11)
      open(12,file='Plots_DLS/fixed.txt',status='unknown',
     &    access='append')
3     read(11,'(a10,1x,f6.2,f7.4,21x,2i3)',end=4)sitt,tct,vvt,i,j
        if(sitt.eq.site(n).and.nnn.le.i+j)then
          if(dabs(hmxu-tct+el(n)/1d3).lt.dsqrt(varc0))then
            write(12,'(a10,2f6.2)')sitt,hmxu+el(n)/1d3,tct
          endif
        endif
      goto3
4     close(11)
      close(12)
c
c Predictive and convergence statistics:
      ncvg=min0(ncvg+1,100)
      dn=dfloat(ncvg)
      do i=1,9
        rmsm(i)=0d0
      enddo
      do i=ncvg,2,-1
        rhws(i)=rhws(i-1)
        rmsm(2)=rmsm(2)+rhws(i)*rhws(i)
        rkws(i)=rkws(i-1)
        rmsm(5)=rmsm(5)+rkws(i)*rkws(i)
        maw(i)=maw(i-1)
        rmsm(7)=rmsm(7)+maw(i)
        mas(i)=mas(i-1)
        rmsm(9)=rmsm(9)+mas(i)
      enddo
      rhws(1)=hmxu-swhh
      rmsm(2)=dsqrt((rmsm(2)+rhws(1)*rhws(1))/dn)
      rkws(1)=kmxu-swkk
      rmsm(5)=dsqrt((rmsm(5)+rkws(1)*rkws(1))/dn)
      maw(1)=wwam/smxo
      rmsm(7)=(rmsm(7)+maw(1))/dn
      mas(1)=swam/smxo
      rmsm(9)=(rmsm(9)+mas(1))/dn
      if(wtn.gt.25d0)then
        do i=ncvg,2,-1
          rhwg(i)=rhwg(i-1)
          rmsm(1)=rmsm(1)+rhwg(i)*rhwg(i)
          rhgs(i)=rhgs(i-1)
          rmsm(3)=rmsm(3)+rhgs(i)*rhgs(i)
          rkwg(i)=rkwg(i-1)
          rmsm(4)=rmsm(4)+rkwg(i)*rkwg(i)
          rkgs(i)=rkgs(i-1)
          rmsm(6)=rmsm(6)+rkgs(i)*rkgs(i)
          mag(i)=mag(i-1)
          rmsm(8)=rmsm(8)+mag(i)
        enddo
        rhwg(1)=hmxu-gwhh
        rmsm(1)=dsqrt((rmsm(1)+rhwg(1)*rhwg(1))/dn)
        rhgs(1)=gwhh-swhh
        rmsm(3)=dsqrt((rmsm(3)+rhgs(1)*rhgs(1))/dn)
        rkwg(1)=kmxu-gwkk
        rmsm(4)=dsqrt((rmsm(4)+rkwg(1)*rkwg(1))/dn)
        rkgs(1)=gwkk-swkk
        rmsm(6)=dsqrt((rmsm(6)+rkgs(1)*rkgs(1))/dn)
        mag(1)=gwam/smxo
        rmsm(8)=(rmsm(8)+mag(1))/dn
      endif
      if(ncvg.eq.100.and.wtn.gt.25d0)then
        write(6,'(a,a)')'Prediction and Convergence Statistics:',
     &      '(Last 100 Sites)'
        write(6,'(a21,f6.3,a12,f6.3,a12,f6.3)')' RMS diff-H wmx-grv: ',
     &      rmsm(1),'; wmx-stat: ',rmsm(2),'; grv-stat: ',rmsm(3)
        write(6,'(a21,f7.5,a12,f7.5,a12,f7.5)')' RMS diff-K wmx-grv: ',
     &      rmsm(4),'; wmx-stat: ',rmsm(5),'; grv-stat: ',rmsm(6)
        write(6,'(a27,f6.3,a7,f6.3,a8,f6.3)')
     &      ' Mean A/A_max for max wmx: ',rmsm(7),'; grv: ',
     &      rmsm(8),'; stat: ',rmsm(9)
c       open(unit=46,file='Plots/pcstats.dat',status='unknown',
        open(unit=46,file='Plots_DLS/pcstats.dat',status='unknown',
     &      access='append')
        write(46,'(i6,9f10.6)')n0,(rmsm(i),i=1,9)
        close(46)
c       open(unit=47,file='Plots/tracks.dat',status='unknown',
        open(unit=47,file='Plots_DLS/tracks.dat',status='unknown',
     &      access='append')
        write(47,'(a,a)')'Prediction and Convergence Statistics:',
     &      '(Last 100 Sites)'
        write(47,'(a21,f6.3,a12,f6.3,a12,f6.3)')' RMS diff-H wmx-grv: ',
     &      rmsm(1),'; wmx-stat: ',rmsm(2),'; grv-stat: ',rmsm(3)
        write(47,'(a21,f7.5,a12,f7.5,a12,f7.5)')' RMS diff-K wmx-grv: ',
     &      rmsm(4),'; wmx-stat: ',rmsm(5),'; grv-stat: ',rmsm(6)
        write(47,'(a27,f6.3,a7,f6.3,a8,f6.3)')
     &      ' Mean A/A_max for max wmx: ',rmsm(7),'; grv: ',
     &      rmsm(8),'; stat: ',rmsm(9)
        close(47)
      endif
c
      return
      end

